/*
 * This function prepares an *.INI file for processing.  There's no error
 * checking on the filename you pass to it.  Returns the number of bytes  
 * read, or NULL on an error condition                                    
 */
int read_ini(char *ini_name)
{
    long len;
    FILE *handle;

    if ((handle=fopen(ini_name, "rb"))==NULL)     /* Binary mode, no CR/LF */
    {                                          /* translation           */
	puts("Error opening INI file");
	return(NULL);
    }
    
    if ((fseek(handle, 0, SEEK_END))!=NULL)
    {
	puts("Error Determining INI file size");
    }

    len=ftell(handle);
    rewind(handle);

    if (len >65534)
    {
	puts("INI file too big");
	return(NULL);
    }
    
    if ((ini_buffer=(char *)malloc(len + 1))==NULL)
    {
	puts("Out of memory");
	return(NULL);
    }
    
    fread(ini_buffer, len, 1, handle);
    ini_buffer[len]='\0';
    
    return (strlen(ini_buffer));
};


/* 
 * O.K. see my previous message for the SAMPLE.INI file to test this  
 * program with.  You'll notice it has [Headers] enclosed in brackets,
 * and always at the beginning of a line.  This routine will locate a 
 * given header, and return a pointer to it, within the global string 
 * ini_buffer.  If not found, returns a pointer to NULL               
 */
char *find_header(char *header_name)
{

    char temp_buf[MAX_CHARS];

    strcpy(temp_buf, NEWLINE);              /* A newline                   */
    strcat(temp_buf, "[");                  /*  and the opening bracket [  */
    strcat(temp_buf, header_name);
    strcat(temp_buf, "]");

    return(strstr(ini_buffer, temp_buf)+strlen(NEWLINE));
};


/* 
 * It's all downhill from here! (not)  Next, this routine scans through  
 * the INI file, starting at offset, and looking for param_name followed 
 * immediately by an "=".  If found, a pointer to the string will be     
 * returned (in the form Value=Parameter, or else a pointer to NULL.     
 */
char *get_parameter(char *dest, char *param_name, char *offset)
{
    char temp_buf1[MAX_CHARS];
    char temp_buf2[MAX_CHARS];
    char *start_ptr;
    char *end_ptr;
    char *too_far_ptr;

    strcpy(temp_buf1, NEWLINE);
    strcat(temp_buf1, param_name);
    strcat(temp_buf1, "=");

    if((start_ptr=strstr(offset, temp_buf1))==NULL)
    {
	*dest=NULL;
	return(dest);
    }
    start_ptr+=strlen(NEWLINE);
    
    if((too_far_ptr=strstr(offset+1, "["))==NULL)
        too_far_ptr=offset+strlen(offset);

    if((end_ptr=strstr(start_ptr, NEWLINE))==NULL)
	end_ptr=start_ptr+strlen(start_ptr);

    if (too_far_ptr<start_ptr)
    {
	*dest=NULL;
	return(dest);
    }

    memcpy(temp_buf2, start_ptr, end_ptr-start_ptr);
    temp_buf2[end_ptr-start_ptr]='\0';

    strcpy(dest, temp_buf2);
    return(dest);
};