//
//  Tool zum erstellen von X.* und D.* - Files aus den von FIDOGATE 
//  erstellen *.msg - Files (ftn2rfc.exe).
//
//  Da ist noch ein Bug drin, wenn man gar keine Parameter angibt!
//
//  Freeware (bin/src) zur freien Verfgung mit der Bitte um
//  Nennung der Quelle -> face@cyberface.north.de (Manfred Ackermann)
//

#define INCL_DOSPROCESS
#include <io.h>
#include <dos.h>
#include <os2.h>
#include <stdio.h>
#include <stdlib.h>
#include <direct.h>
#include <string.h>
#include <malloc.h>
#include <process.h>
#include "configf.h"

char *job_id( int update );

int main( int argc, char **argv )
{
    char           dest[MAX_CHARS], inifile[254];
    char           pcSearchPath[254], pcMsgFile[254], pcSpoolDir[254];
    char           pcRdFile[254], pcRxFile[254];
    char           pcZeile[254], Sender[254], Node[254], Empf[254];
    char           mynode[31], mydomain[31];
    char           RdFile[15], RxFile[15];
    char           *job, *offset;
    unsigned       rc, count=0, sf, ef, c;
    struct find_t  fileinfo;
    FILE           *pFRxFile, *pFRdFile;

    // Read INI-File
    strcpy( inifile, argv[0] );
    *(inifile+strlen(inifile)-4)=0;
    strcat( inifile, ".INI" );
    read_ini( inifile );

    // Locate INI-File entries
    offset=find_header("Names");
    get_parameter(dest, "Host", offset);
    strncpy( mynode,   strchr( dest, '=')+1, strlen( strchr( dest, '=') ) );
    get_parameter(dest, "Domain", offset);
    strncpy( mydomain, strchr( dest, '=')+1, strlen( strchr( dest, '=') ) );

    if( argc>=2 )
    {
	// If Argument then use as SpoolDir
	strcpy( pcSpoolDir, argv[1] );
    }
    else
    {
	// Else take INI-entries
	offset=find_header("Path");
	get_parameter(dest, "Spool", offset);
	strncpy( pcSpoolDir,   strchr( dest, '=')+1, strlen( strchr( dest, '=') ) );
    };

    printf("\n\n----- *.MSG to D.* & X.* Converter -----\n\n");
    printf( "Hostname   : %s\n", mynode   );
    printf( "Domainname : %s\n", mydomain );
    printf( "SpoolDir   : %s ",  pcSpoolDir );
    if( argc>=2 )
	printf( "(by parameter)\n" );
    else
	printf( "(by configfile)\n" );
    strlwr( argv[2] );
    if( strncmp( argv[2], "news", 4 )==0 )
	printf( "MailType   : news\n\n" );
    else
	printf( "MailType   : mail\n\n" );
    
    strcpy( pcSearchPath, pcSpoolDir );
    strcat( pcSearchPath, "/*.msg" );
    rc = _dos_findfirst( pcSearchPath, _A_NORMAL, &fileinfo );

    while( rc == 0 ) 
    {
	job = job_id(1);
	sprintf(RdFile, "D.%.7s0%sr", mynode , job);
	sprintf(RxFile, "X.%.7s0%sr", mynode , job);
	
	// Rename to D.file
	strcpy( pcMsgFile, pcSpoolDir );
        strcat( pcMsgFile, "/" );
        strcat( pcMsgFile, fileinfo.name );
	strcpy( pcRdFile, pcSpoolDir );
        strcat( pcRdFile, "/" );
        strcat( pcRdFile, RdFile );
	rename( pcMsgFile, pcRdFile);

	
	if( strncmp( argv[2], "news", 4 )==0 )
	{
	    // Create X.file for rnews
	    sprintf( pcRxFile, "%s/%s", pcSpoolDir, RxFile );
	    pFRxFile = fopen(pcRxFile, "wb");
	    if( pFRxFile != NULL)
	    {
		fprintf( pFRxFile, "R news %s\n", mydomain );
		fprintf( pFRxFile, "U news %s\n", mynode );
		fprintf( pFRxFile, "F %s\n", RdFile );
		fprintf( pFRxFile, "I %s\n", RdFile );
		fprintf( pFRxFile, "C %s\n", "rnews" );
		fclose( pFRxFile );
	    };
	}else
	{
	    // Create X.file for rmail
	    sprintf( pcRxFile, "%s/%s", pcSpoolDir, RxFile );
	    pFRxFile = fopen(pcRxFile, "wb");
	    if( pFRxFile != NULL)
	    {
		pFRdFile = fopen(pcRdFile, "rb");
		if( pFRdFile != NULL)
		{
		    sf=ef=0;
		    while( ((sf==0) || (ef==0)) && (feof( pFRdFile )==0) )
		    {
			fgets( pcZeile, 254, pFRdFile );

			if( strncmp( pcZeile, "To: ", 4 )==0 )
			{
			    strcpy( Empf, pcZeile+4 );
			    // LF raus
			    for(c=0;Empf[c]!=0x00;c++)
				if(Empf[c+1]==0x0A)
				    Empf[c+1]=0x00;
			    ef=1;
			};
			
			if( strncmp( pcZeile, "From: ", 6 )==0 )
			{
 			    // Copy ab hinter "From: " bis "@"+1
			    strncpy( Sender, pcZeile+6, strcspn( pcZeile+6, "@")+1 );
			    // '@' zu 0x00
			    for(c=0;Sender[c]!=0x00;c++)
				if(Sender[c+1]==0x40)
				    Sender[c+1]=0x00;
			    // Copy ab hinter "@"+1
			    strcpy( Node, pcZeile+strcspn( pcZeile, "@")+1 );
			    // '.' zu 0x00
			    for(c=0;Node[c]!=0x00;c++)
				if(Node[c+1]==0x2E)
				    Node[c+1]=0x00;
			    sf=1;
			};
		    };
                    fclose( pFRdFile );
		};
		
		printf("Msg from %s (%s) to %s\n", Sender, Node, Empf );

		fprintf( pFRxFile, "U %s %s\n", Sender, Node );
		fprintf( pFRxFile, "F %s\n", RdFile );
		fprintf( pFRxFile, "I %s\n", RdFile );
		fprintf( pFRxFile, "C rmail %s\n", Empf );
		fclose( pFRxFile );
		
		Sender[0]=0x00;
		Node[0]=0x00;
		Empf[0]=0x00;
	    };
	};

	printf( "Converted: %ld\015", ++count );

        rc = _dos_findnext( &fileinfo );
    };
    _dos_findclose( &fileinfo );

    printf("\n\n");
    return(0);
};

char *job_id( int update )
{
    static char job[4];
    static char set[] = "0123456789abcdefghijklmnopqrstuvwxyz";
    static long base = sizeof(set) - 1;
    long seq;
    size_t c;
    FILE *fp;
    
    /* Read last sequence number */
    fp = fopen("SEQF", "rt");
    if(fp) 
    {
        if(fscanf(fp, "%ld", &seq) != 1)
            seq = getpid();
        fclose(fp);
    }
    else
    {
        seq = getpid();
    };

    /* Update next sequence number */
    if(update) 
    {
        fp = fopen("SEQF", "wt");
        if(fp) 
	{
            fprintf(fp, "%ld\n", seq + 1);
            fclose(fp);
        };
    };

    /* Convert sequence to 3-char job id */
    seq %= base * base * base;
    job[c = sizeof(job) - 1] = '\0';
    while(c-- > 0) 
    {
        job[c] = set[seq % base];
        seq /= base;
    };
    return(job);
};